#pragma once

#include <exception>
#include <ostream>
#include <string>

#include "Bureaucrat.hpp"
class Bureaucrat;

class Form
{
	private:
		const std::string _name;
		bool _signed;
		int _to_sign;
		int _to_execute;
	
	public:
		Form();
		Form(const std::string& name, int to_execute, int to_sign);
		Form(const Form& src);
		~Form();

		Form& operator=(const Form& src);

		const std::string& getName() const;
		bool getSigned() const;
		int getGradeToBeExecute() const;
		int getGradeToBeSign() const;

		void beSigned(const Bureaucrat& bureaucrat);

	class GradeTooHighException: public std::exception
	{
		public:
			const char * what() const throw();
	};
	
	class GradeTooLowException: public std::exception
	{
		public:
			const char * what() const throw();
	};

};

std::ostream& operator<<(std::ostream& os, const Form& src);
